#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <graphics.h>
#include "ctool-cc.h"

FILE           *STDFONT64,
               *SPCFONT64;

unsigned int    convert_big5_to_serial(unsigned char first, unsigned char second)
{
    unsigned int    sernum,
                    serbase;

    if (first == 0xc6 && second >= 0xa1) {
        serbase = 0x8001;
        first -= 0xc6;
        second = second - 0xa1;
        sernum = first * 0x9d + second + serbase;
        return (sernum);
    };

    if (first >= 0xa1 && first <= 0xa3) {
        serbase = 0x8400;
        first -= 0xa1;
    } else if (first >= 0xa4 && first <= 0xc6) {
        serbase = 0x8800;
        first -= 0xa4;
    } else if (first >= 0xc7 && first <= 0xc8) {
        serbase = 0x805f;
        first -= 0xc7;
    } else if (first >= 0xc9 && first <= 0xf9) {
        serbase = 0x9d19;
        first -= 0xc9;
    } else
        return (0);

    if (second >= 0x40 && second <= 0x7e)
        second -= 0x40;
    else if (second >= 0xa1 && second <= 0xfe)
        second = second - 0xa1 + 0x3f;
    else
        return (0);

    sernum = first * 0x9d + second + serbase;
    return (sernum);
}

void            fill_bitmap_pattern(unsigned char charbuf[], int bpc, int x, int y, unsigned char fg_color)
{
    int             i,
                    j,
                    size,
                    unit_size;
    unsigned char   img[516];

    size = imagesize(x, y, x + 7, y + bpc - 1);
    getimage(x, y, x + 7, y + bpc - 1, &img);
    unit_size = (size - 4) / bpc;

    for (i = 0; i < bpc; i++) {
        for (j = 0; j < unit_size; j++)
            img[4 + i * unit_size + j] =
                (img[4 + i * unit_size + j] & (0xff - charbuf[i])) |
                (charbuf[i] & (((fg_color & (1 << (unit_size - j - 1))) != 0) * 255));
    }

    putimage(x, y, img, 0);
}

void            open_etccdb_font(char dir[])
{
    char            maindir[80];

    strcpy(maindir, dir);
    strcat(maindir, "STDFONT.64");
    if ((STDFONT64 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open STDFONT.64");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "SPCFONT.64");
    if ((SPCFONT64 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open SPCFONT.64");
        exit(1);
    };
}

void            close_etccdb_font()
{
    fclose(STDFONT64);
    fclose(SPCFONT64);
}

void            search_etccdb_big5_font(unsigned sernum, unsigned char pattern[72], int fontsize)
{
    int             i,
                    j,
                    k;
    long int        sernum2;
    unsigned char   tmp_pattern[512],
                    tmp1_pattern[512];

    if (sernum >= 0x8001 && sernum <= 0x816d) {
        for (i = 0; i < (fontsize * fontsize / 8); i++)
            tmp_pattern[i] = 0;
    } else if (sernum >= 0x8400 && sernum <= 0x8597) {
        sernum2 = (long) (sernum - 0x8400) * 512;
        fseek(SPCFONT64, sernum2, 0);
        if (fontsize == 64) {
            fread(tmp_pattern, 1, 512, SPCFONT64);
        } else {
            fread(tmp1_pattern, 1, 512, SPCFONT64);
            varsize(64, 64, fontsize, fontsize, tmp1_pattern, tmp_pattern);
        }
    } else if (sernum >= 0x8800 && sernum <= 0xBB25) {
        sernum2 = (long) (sernum - 0x8800) * 512;
        fseek(STDFONT64, sernum2, 0);
        if (fontsize == 64) {
            fread(tmp_pattern, 1, 512, STDFONT64);
        } else {
            fread(tmp1_pattern, 1, 512, STDFONT64);
            varsize(64, 64, fontsize, fontsize, tmp1_pattern, tmp_pattern);
        }
    };

    for (i = 0; i <= (fontsize / 8) * (fontsize - 1); i += (fontsize / 8))
        for (j = 0; j < (fontsize / 8); j++)
            pattern[j * fontsize + i / (fontsize / 8)] = tmp_pattern[i + j];
}

void            display_etccdb_unshifted_big5_font(unsigned char pattern[512], int fontsize, int x, int y, unsigned char fg_color)
{
    int             i;

    for (i = 0; i <= (fontsize / 8 - 1); i++)
        fill_bitmap_pattern(&pattern[i * fontsize], fontsize, x + i * 8, y, fg_color);
}

void            display_etccdb_big5_font(unsigned char pattern[512], int fontsize, int x, int y, unsigned char fg_color)
{
    int             i;

    display_etccdb_unshifted_big5_font(pattern, fontsize, x, y, fg_color);
}

void            display_etccdb_big5_font_string(unsigned char str[40], int fontsize, int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    unsigned char   pattern[512];

    len = strlen(str);
    for (i = 0; i < len; i += 2) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        search_etccdb_big5_font(sernum, pattern, fontsize);
        if (i != 0)
            x = x + fontsize + sp;
        display_etccdb_big5_font(pattern, fontsize, x, y, fg_color);
    }
}

int             varsize(int old_row, int old_column, int new_row,
                             int new_column, unsigned char old_pattern[512],
                                        unsigned char new_pattern[512])
{
    int            *bct,
                    bcnt[256];
    register        i,
                    j,
                    k;
    int             mas,
                    mi,
                    tims;
    int            *tmp;
    int             old_pat[64 * 64 * sizeof(int)],
                    new_pat[64 * 64 * sizeof(int)];

    for (i = 0; i < 256; i++)
        bcnt[i] = 0;
    expand(old_row, old_column, old_pattern, old_pat);

    if ((old_row >= new_row) && (old_column >= new_column)) {
        mini(old_column, new_column, bcnt);
        smalc(old_column, new_column, old_pat, bcnt);
        for (i = 0; i < old_row; i++)
            bcnt[i] = 0;
        mini(old_row, new_row, &bcnt[0]);
        smalr(old_column, new_column, old_pat, new_pat, bcnt);
    }
    pack(new_row, new_column, new_pat, new_pattern);
    return (1);
}

void            expand(int old_row, int old_column, char *source_pattern,
                                       int *dest_pattern)
{
    register        i,
                    j,
                    k;
    int             x,
                    y,
                    data;
    int            *tmp;

    for (i = 0; i < old_row; i++)
        for (j = 0; j < (old_column / 8); j++) {
            x = i;
            y = j * 8 + 7;
            tmp = dest_pattern + x * old_column + y;
            data = (int) (*source_pattern);
            for (k = 0; k < 8; k++) {
                if ((data % 2) == 0)
                    *tmp = 0;
                else
                    *tmp = 1;
                data = data >> 1;
                tmp--;
            }
            source_pattern++;
        }
}

void            pack(int new_row, int new_column, int *source_pattern,
                                     char *dest_pattern)
{
    register        i,
                    j,
                    k;
    int             data;
    char           *tmp;

    for (i = 0; i < new_row; i++)
        for (j = 0; j < (new_column / 8); j++) {
            tmp = dest_pattern + i * (new_column / 8) + j;
            data = 0;
            for (k = 0; k < 8; k++) {
                if (*source_pattern++ == 0)
                    data = (data << 1) | 0;
                else
                    data = (data << 1) | 1;
            }
            *tmp++ = data;
        }
}

int             mini(int ori, int mi, int *pb)
{
    int             i,
                    j,
                    k,
                    n,
                    mm,
                    ex,
                    ipl,
                    add,
                    per;
    int            *ipb;

    if (ori == mi) {
        for (i = 0; i < 64; i++)
            *pb++ = i;
    } else {
        ipb = pb;
        ex = mat(ori);
        mm = mat(mi);

        for (i = 0; i < ex; i++) {
            pb = ipb;
            ipl = exp(i);
            pb += ipl;
            per = ipl * 2;
            while (ipl < ori) {
                *pb |= 1;
                pb += per;
                ipl += per;
            }
            if (i < (ex - 1))
                for (k = 0, pb = ipb; k < ori; k++, pb++)
                    *pb = *pb << 1;
        }
        for (pb = ipb; pb < (ipb + ori); pb++)
            *pb &= mi;
    }
    return (1);
}

int             exp(int k)
{
    int             i,
                    mul;

    mul = 1;
    if (k == 0)
        return (1);
    else {
        for (i = 0; i < k; i++)
            mul *= 2;
        return (mul);
    }
}

int             mat(int ma)
{
    int             count;

    count = 0;
    if ((ma / 2) == 0)
        return (-1);
    while ((ma = ma / 2) != 0)
        count++;
    return (count);
}

int             smalc(int lar, int sma, int *tw, int *bnt)
{
    int             i,
                    j,
                    k,
                    count;
    int            *itw,
                   *ibnt,
                   *tw2,
                   *tt,
                   *ntw;

    ibnt = bnt;
    itw = tw;
    count = 0;
    tw2 = itw;
    bnt = ibnt;
    for (i = 0; i < lar; i++, bnt = ibnt) {
        for (j = 0; j < lar; j++, tw++, bnt++)
            if (*bnt != 0) {
                count = 0;
                if (j != 0) {
                    if (*--bnt == 0) {
                        tt = tw - 1;
                        if (*tw == 0)
                            *tw = *tw | *tt;
                        else {
                            tw2 = tw + 1;
                            ntw = tw + lar;
                            if (*tt == 0 && *tw2 == 0 && *ntw != 0)
                                *tw = 1;
                            else
                                *tw = *tw & *tt;
                        }
                    }
                    bnt++;
                }
            } else {
                count++;
                if (count == 2) {
                    tw -= 2;
                    tt = tw + 1;
                    if (*tw == 0)
                        *tw = *tw | *tt;
                    else {
                        tw2 = tw + 1;
                        ntw = tw + lar;
                        if (*tt == 0 && *tw2 == 0 && *ntw != 0)
                            *tw = 1;
                        else
                            *tw = *tw & *tt;
                    }
                    tw += 2;
                }
            }

    }
    for (i = 0, tw = itw, bnt = ibnt, tw2 = itw; i < lar;
         i++, tw += lar - sma, bnt = ibnt) {
        for (j = 0; j < lar; j++, tw2++, bnt++)
            if (*bnt != 0)
                *tw++ = *tw2;

    }
    return (1);
}

int             smalr(int lar, int sm1, int *tw, int *new, int *bnt)
{                               /* processing every column */
    int            *itw,
                   *ibnt,
                   *tw2,
                   *tt,
                   *ntw;
    int             i,
                    j,
                    k,
                    count;
    ibnt = bnt;
    itw = tw;
    count = 0;
    tw2 = itw;
    for (i = 0; i < sm1; i++, bnt = ibnt, tw = tw - (lar) * lar + 1) {
        for (j = 0; j < lar; j++, tw += lar, bnt++)
            if (*bnt != 0) {
                count = 0;
                if (j != 0) {
                    tt = tw - lar;
                    if (*--bnt == 0) {
                        if (*tw == 0)
                            *tw = *tw | *tt;
                        else {
                            ntw = tw + 1;
                            tw2 = tw + lar;
                            if (*tt == 0 && *tw2 == 0 && *ntw != 0)
                                *tw = 1;
                            else
                                *tw = *tw & *tt;
                        }
                    }
                    bnt++;
                }
            } else {
                count++;
                if (count == 2) {
                    tw -= 2 * lar;
                    tt = tw + lar;
                    if (*tw == 0)
                        *tw = *tw | *tt;
                    else {
                        ntw = tw + 1;
                        tw2 = tw + lar;
                        if (*tt == 0 && *tw2 == 0 && *ntw != 0)
                            *tw = 1;
                        else
                            *tw = *tw & *tt;
                    }
                    tw = tt + lar;
                }
            }
    }
    for (i = 0, tw = itw, bnt = ibnt; i < lar; i++, bnt++) {

        if ((*bnt) != 0) {
            for (j = 0; j < sm1; j++, tw++)
                *new++ = *tw;
            tw += lar - sm1;
        } else
            tw += lar;
    }
    return (1);
}
