#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <graphics.h>
#include "ctool-et.h"

FILE           *STDFONT24,
               *SPCFONT24,
               *SPCSUPP24,
               *ASCFONT24,
               *STDFONT15,
               *SPCFONT15,
               *SPCSUPP15,
               *ASCFONT15;

unsigned int    convert_big5_to_serial(unsigned char first, unsigned char second)
{
    unsigned int    sernum,
                    serbase;

    if (first == 0xc6 && second >= 0xa1) {
        serbase = 0x8001;
        first -= 0xc6;
        second = second - 0xa1;
        sernum = first * 0x9d + second + serbase;
        return (sernum);
    };

    if (first >= 0xa1 && first <= 0xa3) {
        serbase = 0x8400;
        first -= 0xa1;
    } else if (first >= 0xa4 && first <= 0xc6) {
        serbase = 0x8800;
        first -= 0xa4;
    } else if (first >= 0xc7 && first <= 0xc8) {
        serbase = 0x805f;
        first -= 0xc7;
    } else if (first >= 0xc9 && first <= 0xf9) {
        serbase = 0x9d19;
        first -= 0xc9;
    } else
        return (0);

    if (second >= 0x40 && second <= 0x7e)
        second -= 0x40;
    else if (second >= 0xa1 && second <= 0xfe)
        second = second - 0xa1 + 0x3f;
    else
        return (0);

    sernum = first * 0x9d + second + serbase;
    return (sernum);
}

void            fill_bitmap_pattern(unsigned char charbuf[], int bpc, int x, int y, unsigned char fg_color)
{
    int             i,
                    j,
                    size,
                    unit_size;
    unsigned char   img[196];

    size = imagesize(x, y, x + 7, y + bpc - 1);
    getimage(x, y, x + 7, y + bpc - 1, &img);
    unit_size = (size - 4) / bpc;

    for (i = 0; i < bpc; i++) {
        for (j = 0; j < unit_size; j++)
            img[4 + i * unit_size + j] =
                (img[4 + i * unit_size + j] & (0xff - charbuf[i])) |
                (charbuf[i] & (((fg_color & (1 << (unit_size - j - 1))) != 0) * 255));
    }

    putimage(x, y, img, 0);
}

void            open_et24_font(char dir[])
{
    char            maindir[80];

    strcpy(maindir, dir);
    strcat(maindir, "STDFONT.24");
    if ((STDFONT24 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open STDFONT.24");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "SPCFONT.24");
    if ((SPCFONT24 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open SPCFONT.24");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "SPCFSUPP.24");
    if ((SPCSUPP24 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open SPCSUPP.24");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "ASCFONT.24");
    if ((ASCFONT24 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open ASCFONT.24");
        exit(1);
    };
}

void            close_et24_font()
{
    fclose(SPCSUPP24);
    fclose(SPCFONT24);
    fclose(STDFONT24);
    fclose(ASCFONT24);
}

void            search_et24_big5_font(unsigned sernum, unsigned char pattern[72])
{
    int             i,
                    j,
                    k;
    long int        sernum2;
    unsigned char   tmp_pattern[72];

    if (sernum >= 0x8001 && sernum <= 0x816d) {
        sernum2 = (long) (sernum - 0x8001) * 72;
        fseek(SPCSUPP24, sernum2, 0);
        fread(tmp_pattern, 1, 72, SPCSUPP24);
    } else if (sernum >= 0x8400 && sernum <= 0x8597) {
        sernum2 = (long) (sernum - 0x8400) * 72;
        fseek(SPCFONT24, sernum2, 0);
        fread(tmp_pattern, 1, 72, SPCFONT24);
    } else if (sernum >= 0x8800 && sernum <= 0xBB25) {
        sernum2 = (long) (sernum - 0x8800) * 72;
        fseek(STDFONT24, sernum2, 0);
        fread(tmp_pattern, 1, 72, STDFONT24);
    };

    for (i = 0; i <= 69; i = i + 3) {
        pattern[i / 3] = tmp_pattern[i];
        pattern[24 + i / 3] = tmp_pattern[i + 1];
        pattern[48 + i / 3] = tmp_pattern[i + 2];
    }
}

void            display_et24_unshifted_big5_font(unsigned char pattern[72], int x, int y, unsigned char fg_color)
{
    int             i;

    for (i = 0; i <= 2; i++)
        fill_bitmap_pattern(&pattern[i * 24], 24, x + i * 8, y, fg_color);
}

void            display_et24_big5_font(unsigned char pattern[72], int x, int y, unsigned char fg_color)
{
    int             i;

    display_et24_unshifted_big5_font(pattern, x, y, fg_color);
}

void            search_et24_ascii_font(unsigned char ascii, unsigned char pattern[48])
{
    int             i,
                    j,
                    k,
                    sernum2;
    unsigned char   tmp_pattern[48];

    sernum2 = ascii * 48;
    fseek(ASCFONT24, sernum2, 0);
    fread(tmp_pattern, 1, 48, ASCFONT24);
    for (i = 0; i <= 47; i = i + 2) {
        pattern[i / 2] = tmp_pattern[i];
        pattern[24 + i / 2] = tmp_pattern[i + 1];
    }
}

void            display_et24_unshifted_ascii_font(unsigned char pattern[48], int x, int y, unsigned char fg_color)
{
    int             i;

    for (i = 0; i <= 1; i++)
        fill_bitmap_pattern(&pattern[i * 24], 24, x + i * 8, y, fg_color);
}

void            display_et24_ascii_font(unsigned char pattern[48], int x, int y, unsigned char fg_color)
{
    int             i;

    display_et24_unshifted_ascii_font(pattern, x, y, fg_color);
}

void            display_et24_big5_font_string(unsigned char str[86], int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    unsigned char   pattern[72];

    len = strlen(str);
    for (i = 0; i < len; i += 2) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        search_et24_big5_font(sernum, pattern);
        if (i != 0)
            x = x + 24 + sp;
        display_et24_big5_font(pattern, x, y, fg_color);
    }
}

void            display_et24_string(unsigned char str[86], int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    char            c = 0;
    unsigned char   big5_pattern[72],
                    ascii_pattern[48];

    len = strlen(str);
    for (i = 0; i < len; i++) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        if (sernum == 0) {
            search_et24_ascii_font(str[i], ascii_pattern);
            if (c == 2)
                x = x + 12 + sp;
            if (i != 0)
                x = x + 12 + sp;
            display_et24_ascii_font(ascii_pattern, x, y, fg_color);
            c = 1;
        } else {
            search_et24_big5_font(sernum, big5_pattern);
            if ((c == 1) && (i != 0))
                x = x + 12 + sp;
            if ((c == 2) && (i != 0))
                x = x + 24 + 2 * sp;
            display_et24_big5_font(big5_pattern, x, y, fg_color);
            c = 2;
            i++;
        }
    }
}

void            open_et15_font(char dir[])
{
    char            maindir[80];

    strcpy(maindir, dir);
    strcat(maindir, "STDFONT.15");
    if ((STDFONT15 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open STDFONT.15");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "SPCFONT.15");
    if ((SPCFONT15 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open SPCFONT.15");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "SPCFSUPP.15");
    if ((SPCSUPP15 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open SPCSUPP.15");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "ASCFONT.15");
    if ((ASCFONT15 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open ASCFONT.15");
        exit(1);
    };
}

void            close_et15_font()
{
    fclose(SPCSUPP15);
    fclose(SPCFONT15);
    fclose(STDFONT15);
    fclose(ASCFONT15);
}

void            search_et15_big5_font(unsigned sernum, unsigned char pattern[30])
{
    int             i,
                    j,
                    k;
    long int        sernum2;
    unsigned char   tmp_pattern[30];

    if (sernum >= 0x8001 && sernum <= 0x816d) {
        sernum2 = (long) (sernum - 0x8001) * 30;
        fseek(SPCSUPP15, sernum2, 0);
        fread(tmp_pattern, 1, 30, SPCSUPP15);
    } else if (sernum >= 0x8400 && sernum <= 0x8597) {
        sernum2 = (long) (sernum - 0x8400) * 30;
        fseek(SPCFONT15, sernum2, 0);
        fread(tmp_pattern, 1, 30, SPCFONT15);
    } else if (sernum >= 0x8800 && sernum <= 0xBB25) {
        sernum2 = (long) (sernum - 0x8800) * 30;
        fseek(STDFONT15, sernum2, 0);
        fread(tmp_pattern, 1, 30, STDFONT15);
    };

    for (i = 0; i <= 28; i = i + 2) {
        pattern[i / 2] = tmp_pattern[i];
        pattern[15 + i / 2] = tmp_pattern[i + 1];
    }
}

void            display_et15_unshifted_big5_font(unsigned char pattern[30], int x, int y, unsigned char fg_color)
{
    int             i;

    for (i = 0; i <= 1; i++)
        fill_bitmap_pattern(&pattern[i * 15], 15, x + i * 8, y, fg_color);
}

void            display_et15_big5_font(unsigned char pattern[30], int x, int y, unsigned char fg_color)
{
    int             i;

    display_et15_unshifted_big5_font(pattern, x, y, fg_color);
}

void            search_et15_ascii_font(unsigned char ascii, unsigned char pattern[15])
{
    int             i,
                    j,
                    k,
                    sernum2;

    sernum2 = ascii * 15;
    fseek(ASCFONT15, sernum2, 0);
    fread(pattern, 1, 15, ASCFONT15);
}

void            display_et15_unshifted_ascii_font(unsigned char pattern[15], int x, int y, unsigned char fg_color)
{
    int             i;

    fill_bitmap_pattern(&pattern[0], 15, x, y, fg_color);
}

void            display_et15_ascii_font(unsigned char pattern[15], int x, int y, unsigned char fg_color)
{
    int             i;

    display_et15_unshifted_ascii_font(pattern, x, y, fg_color);
}

void            display_et15_big5_font_string(unsigned char str[128], int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    unsigned char   pattern[30];

    len = strlen(str);
    for (i = 0; i < len; i += 2) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        search_et15_big5_font(sernum, pattern);
        if (i != 0)
            x = x + 16 + sp;
        display_et15_big5_font(pattern, x, y, fg_color);
    }
}

void            display_et15_string(unsigned char str[128], int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    char            c = 0;
    unsigned char   big5_pattern[30],
                    ascii_pattern[15];

    len = strlen(str);
    for (i = 0; i < len; i++) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        if (sernum == 0) {
            search_et15_ascii_font(str[i], ascii_pattern);
            if (c == 2)
                x = x + 8 + sp;
            if (i != 0)
                x = x + 8 + sp;
            display_et15_ascii_font(ascii_pattern, x, y, fg_color);
            c = 1;
        } else {
            search_et15_big5_font(sernum, big5_pattern);
            if ((c == 1) && (i != 0))
                x = x + 8 + sp;
            if ((c == 2) && (i != 0))
                x = x + 16 + 2 * sp;
            display_et15_big5_font(big5_pattern, x, y, fg_color);
            c = 2;
            i++;
        }
    }
}
