#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <graphics.h>
#include "ctool-kc.h"

FILE           *KCCHIN24,
               *KCTEXT24,
               *KCCHIN16,
               *KCTEXT16;

unsigned int    convert_big5_to_serial(unsigned char first, unsigned char second)
{
    unsigned int    sernum,
                    serbase;

    if (first == 0xc6 && second >= 0xa1) {
        serbase = 0x8001;
        first -= 0xc6;
        second = second - 0xa1;
        sernum = first * 0x9d + second + serbase;
        return (sernum);
    };

    if (first >= 0xa1 && first <= 0xa3) {
        serbase = 0x8400;
        first -= 0xa1;
    } else if (first >= 0xa4 && first <= 0xc6) {
        serbase = 0x8800;
        first -= 0xa4;
    } else if (first >= 0xc7 && first <= 0xc8) {
        serbase = 0x805f;
        first -= 0xc7;
    } else if (first >= 0xc9 && first <= 0xf9) {
        serbase = 0x9d19;
        first -= 0xc9;
    } else
        return (0);

    if (second >= 0x40 && second <= 0x7e)
        second -= 0x40;
    else if (second >= 0xa1 && second <= 0xfe)
        second = second - 0xa1 + 0x3f;
    else
        return (0);

    sernum = first * 0x9d + second + serbase;
    return (sernum);
}

void            fill_bitmap_pattern(unsigned char charbuf[], int bpc, int x, int y, unsigned char fg_color)
{
    int             i,
                    j,
                    size,
                    unit_size;
    unsigned char   img[196];

    size = imagesize(x, y, x + 7, y + bpc - 1);
    getimage(x, y, x + 7, y + bpc - 1, &img);
    unit_size = (size - 4) / bpc;

    for (i = 0; i < bpc; i++) {
        for (j = 0; j < unit_size; j++)
            img[4 + i * unit_size + j] =
                (img[4 + i * unit_size + j] & (0xff - charbuf[i])) |
                (charbuf[i] & (((fg_color & (1 << (unit_size - j - 1))) != 0) * 255));
    }

    putimage(x, y, img, 0);
}

void            open_kc24_font(char dir[])
{
    char            maindir[80];

    strcpy(maindir, dir);
    strcat(maindir, "KCCHIN24.F00");
    if ((KCCHIN24 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open KCCHIN24.F00");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "KCTEXT24.F00");
    if ((KCTEXT24 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open KCTEXT24.F00");
        exit(1);
    };
}

void            close_kc24_font()
{
    fclose(KCCHIN24);
    fclose(KCTEXT24);
}

void            search_kc24_big5_font(unsigned sernum, unsigned char pattern[72])
{
    int             i,
                    j,
                    k;
    long int        sernum2,
                    kc_offset = -1;
    unsigned char   tmp_pattern[72];

    if (sernum >= 0x8800 && sernum <= 0xBB25) {
        sernum2 = (long) (sernum - 0x8800);
        if (sernum2 >= 0 && sernum2 <= 13052)
            kc_offset = sernum2 + 765;
        else if (sernum2 >= 13054)
            kc_offset = sernum2 + 823;
        else if (sernum2 == 13053)
            kc_offset = 408;
    };

    if (sernum >= 0x8400 && sernum <= 0x8597) {
        sernum2 = (long) (sernum - 0x8400);
        kc_offset = sernum2;
    };

    if (sernum >= 0x8001 && sernum <= 0x816d) {
        sernum2 = (long) (sernum - 0x8001);
        if (sernum2 >= 0 && sernum2 <= 29)
            kc_offset = sernum2 + 411;
        else if (sernum2 == 30)
            kc_offset = 13818;
        else if (sernum2 >= 31 && sernum2 <= 33)
            kc_offset = sernum2 + 411;
        else if (sernum2 >= 34 && sernum2 <= 37)
            kc_offset = sernum2 - 34 + 446;
        else if (sernum2 >= 38 && sernum2 <= 40)
            kc_offset = sernum2 - 38 + 451;
        else if (sernum2 >= 42 && sernum2 <= 50)
            kc_offset = sernum2 - 42 + 456;
        else if (sernum2 >= 51 && sernum2 <= 52)
            kc_offset = sernum2 - 51 + 466;
        else if (sernum2 >= 53 && sernum2 <= 54)
            kc_offset = sernum2 - 53 + 469;
        else if (sernum2 >= 55 && sernum2 <= 66)
            kc_offset = sernum2 - 55 + 506;
        else if (sernum2 >= 67 && sernum2 <= 69)
            kc_offset = sernum2 - 67 + 520;
        else if (sernum2 >= 70 && sernum2 <= 305)
            kc_offset = sernum2 - 70 + 525;
        else if (sernum2 >= 306 && sernum2 <= 307)
            kc_offset = sernum2 - 306 + 763;
        else if (sernum2 >= 308 && sernum2 <= 364)
            kc_offset = sernum2 - 308 + 13820;
    };

    for (i = 0; i <= 71; i++)
        tmp_pattern[i] = 0;

    if (kc_offset >= 0) {
        fseek(KCCHIN24, 256 + kc_offset * 72, 0);
        fread(tmp_pattern, 1, 72, KCCHIN24);
    };

    for (i = 0; i <= 69; i = i + 3) {
        pattern[i / 3] = tmp_pattern[i];
        pattern[24 + i / 3] = tmp_pattern[i + 1];
        pattern[48 + i / 3] = tmp_pattern[i + 2];
    }
}

void            display_kc24_unshifted_big5_font(unsigned char pattern[72], int x, int y, unsigned char fg_color)
{
    int             i;

    for (i = 0; i <= 2; i++)
        fill_bitmap_pattern(&pattern[i * 24], 24, x + i * 8, y, fg_color);
}

void            display_kc24_big5_font(unsigned char pattern[72], int x, int y, unsigned char fg_color)
{
    int             i;

    display_kc24_unshifted_big5_font(pattern, x, y, fg_color);
}

void            search_kc24_ascii_font(unsigned char ascii, unsigned char pattern[48])
{
    int             i,
                    j,
                    k,
                    sernum2;
    unsigned char   tmp_pattern[48];

    sernum2 = ascii * 48;
    fseek(KCTEXT24, 256 + sernum2, 0);
    fread(tmp_pattern, 1, 48, KCTEXT24);
    for (i = 0; i <= 47; i = i + 2) {
        pattern[i / 2] = tmp_pattern[i];
        pattern[24 + i / 2] = tmp_pattern[i + 1];
    }
}

void            display_kc24_unshifted_ascii_font(unsigned char pattern[48], int x, int y, unsigned char fg_color)
{
    int             i;

    for (i = 0; i <= 1; i++)
        fill_bitmap_pattern(&pattern[i * 24], 24, x + i * 8, y, fg_color);
}

void            display_kc24_ascii_font(unsigned char pattern[48], int x, int y, unsigned char fg_color)
{
    int             i;

    display_kc24_unshifted_ascii_font(pattern, x, y, fg_color);
}

void            display_kc24_big5_font_string(unsigned char str[86], int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    unsigned char   pattern[72];

    len = strlen(str);
    for (i = 0; i < len; i += 2) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        search_kc24_big5_font(sernum, pattern);
        if (i != 0)
            x = x + 24 + sp;
        display_kc24_big5_font(pattern, x, y, fg_color);
    }
}

void            display_kc24_string(unsigned char str[86], int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    char            c = 0;
    unsigned char   big5_pattern[72],
                    ascii_pattern[48];

    len = strlen(str);
    for (i = 0; i < len; i++) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        if (sernum == 0) {
            search_kc24_ascii_font(str[i], ascii_pattern);
            if (c == 2)
                x = x + 12 + sp;
            if (i != 0)
                x = x + 12 + sp;
            display_kc24_ascii_font(ascii_pattern, x, y, fg_color);
            c = 1;
        } else {
            search_kc24_big5_font(sernum, big5_pattern);
            if ((c == 1) && (i != 0))
                x = x + 12 + sp;
            if ((c == 2) && (i != 0))
                x = x + 24 + 2 * sp;
            display_kc24_big5_font(big5_pattern, x, y, fg_color);
            c = 2;
            i++;
        }
    }
}

void            open_kc15_font(char dir[])
{
    char            maindir[80];

    strcpy(maindir, dir);
    strcat(maindir, "KCCHIN16.F00");
    if ((KCCHIN16 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open KCCHIN16.F00");
        exit(1);
    };

    strcpy(maindir, dir);
    strcat(maindir, "KCTEXT16.F00");
    if ((KCTEXT16 = fopen(maindir, "rb")) == NULL) {
        puts("\nCannot open KCTEXT16.F00");
        exit(1);
    };
}

void            close_kc15_font()
{
    fclose(KCCHIN16);
    fclose(KCTEXT16);
}

void            search_kc15_big5_font(unsigned sernum, unsigned char pattern[32])
{
    int             i,
                    j,
                    k;
    long int        sernum2,
                    kc_offset = -1;
    unsigned char   tmp_pattern[32];

    if (sernum >= 0x8800 && sernum <= 0xBB25) {
        sernum2 = (long) (sernum - 0x8800);
        if (sernum2 >= 0 && sernum2 <= 13052)
            kc_offset = sernum2 + 765;
        else if (sernum2 >= 13054)
            kc_offset = sernum2 + 823;
        else if (sernum2 == 13053)
            kc_offset = 408;
    };

    if (sernum >= 0x8400 && sernum <= 0x8597) {
        sernum2 = (long) (sernum - 0x8400);
        kc_offset = sernum2;
    };

    if (sernum >= 0x8001 && sernum <= 0x816d) {
        sernum2 = (long) (sernum - 0x8001);
        if (sernum2 >= 0 && sernum2 <= 29)
            kc_offset = sernum2 + 411;
        else if (sernum2 == 30)
            kc_offset = 13818;
        else if (sernum2 >= 31 && sernum2 <= 33)
            kc_offset = sernum2 + 411;
        else if (sernum2 >= 34 && sernum2 <= 37)
            kc_offset = sernum2 - 34 + 446;
        else if (sernum2 >= 38 && sernum2 <= 40)
            kc_offset = sernum2 - 38 + 451;
        else if (sernum2 >= 42 && sernum2 <= 50)
            kc_offset = sernum2 - 42 + 456;
        else if (sernum2 >= 51 && sernum2 <= 52)
            kc_offset = sernum2 - 51 + 466;
        else if (sernum2 >= 53 && sernum2 <= 54)
            kc_offset = sernum2 - 53 + 469;
        else if (sernum2 >= 55 && sernum2 <= 66)
            kc_offset = sernum2 - 55 + 506;
        else if (sernum2 >= 67 && sernum2 <= 69)
            kc_offset = sernum2 - 67 + 520;
        else if (sernum2 >= 70 && sernum2 <= 305)
            kc_offset = sernum2 - 70 + 525;
        else if (sernum2 >= 306 && sernum2 <= 307)
            kc_offset = sernum2 - 306 + 763;
        else if (sernum2 >= 308 && sernum2 <= 364)
            kc_offset = sernum2 - 308 + 13820;
    };

    for (i = 0; i <= 31; i++)
        tmp_pattern[i] = 0;

    if (kc_offset >= 0 && kc_offset <= 764) {
        fseek(KCCHIN16, 256 + kc_offset * 32, 0);
        fread(tmp_pattern, 1, 32, KCCHIN16);
    } else if (kc_offset >= 765) {
        fseek(KCCHIN16, 256 + 24480 + (kc_offset - 765) * 28, 0);
        fread(tmp_pattern, 1, 28, KCCHIN16);
    };

    for (i = 0; i <= 30; i = i + 2) {
        pattern[i / 2] = tmp_pattern[i];
        pattern[16 + i / 2] = tmp_pattern[i + 1];
    }
}

void            display_kc15_unshifted_big5_font(unsigned char pattern[32], int x, int y, unsigned char fg_color)
{
    int             i;

    for (i = 0; i <= 1; i++)
        fill_bitmap_pattern(&pattern[i * 16], 16, x + i * 8, y, fg_color);
}

void            display_kc15_big5_font(unsigned char pattern[32], int x, int y, unsigned char fg_color)
{
    int             i;

    display_kc15_unshifted_big5_font(pattern, x, y, fg_color);
}

void            search_kc15_ascii_font(unsigned char ascii, unsigned char pattern[16])
{
    int             i,
                    j,
                    k,
                    sernum2;

    sernum2 = ascii * 16;
    fseek(KCTEXT16, 256 + sernum2, 0);
    fread(pattern, 1, 16, KCTEXT16);
}

void            display_kc15_unshifted_ascii_font(unsigned char pattern[16], int x, int y, unsigned char fg_color)
{
    int             i;

    fill_bitmap_pattern(&pattern[0], 16, x, y, fg_color);
}

void            display_kc15_ascii_font(unsigned char pattern[16], int x, int y, unsigned char fg_color)
{
    int             i;

    display_kc15_unshifted_ascii_font(pattern, x, y, fg_color);
}

void            display_kc15_big5_font_string(unsigned char str[128], int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    unsigned char   pattern[32];

    len = strlen(str);
    for (i = 0; i < len; i += 2) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        search_kc15_big5_font(sernum, pattern);
        if (i != 0)
            x = x + 16 + sp;
        display_kc15_big5_font(pattern, x, y, fg_color);
    }
}

void            display_kc15_string(unsigned char str[128], int x, int y, int sp, unsigned char fg_color)
{
    unsigned int    sernum;
    int             i,
                    len;
    char            c = 0;
    unsigned char   big5_pattern[32],
                    ascii_pattern[16];

    len = strlen(str);
    for (i = 0; i < len; i++) {
        sernum = convert_big5_to_serial(str[i], str[i + 1]);
        if (sernum == 0) {
            search_kc15_ascii_font(str[i], ascii_pattern);
            if (c == 2)
                x = x + 8 + sp;
            if (i != 0)
                x = x + 8 + sp;
            display_kc15_ascii_font(ascii_pattern, x, y, fg_color);
            c = 1;
        } else {
            search_kc15_big5_font(sernum, big5_pattern);
            if ((c == 1) && (i != 0))
                x = x + 8 + sp;
            if ((c == 2) && (i != 0))
                x = x + 16 + 2 * sp;
            display_kc15_big5_font(big5_pattern, x, y, fg_color);
            c = 2;
            i++;
        }
    }
}
